<?php
/**
 * @package merchant
 *
 * @author Qinii
 * @day 2020-06-12
 *
 *
 */
namespace app\controller\merchant\store\order;

use app\common\repositories\store\order\MerchantReconciliationRepository;
use app\common\repositories\store\order\StoreRefundStatusRepository;
use think\App;
use crmeb\basic\BaseController;
use app\common\repositories\store\order\StoreRefundOrderRepository as repository;
use think\facade\Db;

class RefundOrder extends BaseController
{
    /**
     * @var repository
     */
    protected $repository;


    /**
     * Order constructor.
     * @param App $app
     * @param repository $repository
     */
    public function __construct(App $app, repository $repository)
    {
        parent::__construct($app);
        $this->repository = $repository;
    }

    /**
     * @return mixed
     * @author Qinii
     * @day 2020-06-12
     */
    public function lst()
    {
        list($page,$limit) = $this->getPage();
        $where = $this->request->params(['refund_order_sn','refund_type','date','order_sn']);
        $status = $this->request->param('status');
        $where['mer_id'] = $this->request->merId();
        return app('json')->success($this->repository->getList($where,$page,$limit,$status));
    }

    /**
     * @param $id
     * @return mixed
     * @author Qinii
     * @day 2020-06-12
     */
    public function detail($id)
    {

        if(!$this->repository->getExistsById($this->request->merId(),$id))
            return app('json')->fail('数据不存在');
        $data=$this->repository->getOne($id);
        return app('json')->success($data);
    }

    /**
     * @param $id
     * @return mixed
     * @author Qinii
     * @day 2020-06-12
     */
    public function switchStatus($id)
    {
        if(!$this->repository->getStatusExists($this->request->merId(),$id))
            return app('json')->fail('信息或状态错误');

        $status=-1;
        if($this->request->param('status') == 1){
            $status=1;
        }else if($this->request->param('status') == 2){
            $status=2;
        }
//        $status = ($this->request->param('status') == 1) ? 1 : -1;
        if($status == 1 || $status == 2){
            $refund_order=$this->repository->get($id);
            if($status==2){
                $part_refund_message = $this->request->param('part_refund_message','');
                $refund_price =(float) $this->request->param('part_refund_price',0);
                if($refund_price<0.01){
                    return app('json')->fail('退款金额不能小于0.01');
                }
                $pay_price=Db::name('store_order')->where('order_id',$refund_order['order_id'])->value('pay_price');
                if($refund_order && $refund_price > $pay_price){
                    return app('json')->fail('退款金额不能大于用户支付金额');
                }
                if($part_refund_message==''){
                    return app('json')->fail('请填写商家备注');
                }
                $this->repository->update($id,['refund_type'=>1,'refund_price'=>$refund_price,'part_refund_price'=>$refund_price,'part_refund_message' => $part_refund_message,'part_refund_time'=>date('Y-m-d H:i:s')]);
            }

            $douduo = $this -> repository -> douduofund($id,true);
            if($douduo['code'] < 0){
                return app('json')->fail($douduo['message']);
            }
            if($douduo['code'] == 2){
                return app('json')->success($douduo['message']);
            }

//            $data = $this->request->params(['mer_delivery_user','mer_delivery_address','phone']);
            $data['mer_delivery_user']=$this->request->param('mer_refund_user','');
            $data['mer_delivery_address']=$this->request->param('mer_refund_address','');
            $data['phone']=$this->request->param('set_phone','');

            if($refund_order['refund_type']==2 && $status == 1 && ($data['mer_delivery_user']=='' || $data['mer_delivery_address']=='' || $data['phone']=='')){
                return app('json')->fail('请输入收货人信息');
            }


            $data['status'] = $status;
            $this->repository->agree($id,$data,$this->request->adminId(),1);

            // 获取订单金额
            $store_order_info = Db::name('store_order')
                ->where('order_id', $refund_order['order_id'])
                ->find();
            $group_order_map = Db::name('store_group_order')
                ->where('group_order_id', $store_order_info['group_order_id'])
                ->field('uid,pay_price,hf_pay_id,fzone_paytype')
                ->find();
            $make = '商贸区';
            if ($store_order_info['mer_id'] == 439) {
                $make = '精彩生活区';
            } else if ($store_order_info['mer_id'] == 496) {
                $make = '会员专区';
            } else if ($store_order_info['mer_id'] == 491) {
                $make = '复购区';
            }

            // 如果是组合支付 现金 + 积分 则需要把积分退回
            // 参考 app\controller\api\Notify.php -- 745 $array_fzone_paytype['type']=='b2'
            $array_fzone_paytype = json_decode($group_order_map['fzone_paytype'], true);
            if (!empty($array_fzone_paytype)) {
                if ($array_fzone_paytype['type'] == 'b1') {
                    // VR+积分 {"checked":true,"note":"VR+积分","other":210.0,"price":970.0,"total":0.0,"type":"b1","vr":"47557.5"}
                    $vrpri = Db::name("user")->where("uid", $group_order_map['uid'])->value('vr');
                    $vrpri += $array_fzone_paytype['price'];
                    Db::name("user")->where("uid", $group_order_map['uid'])->update(['vr' => $vrpri]);
                    Db::name("user_sign_vr")->insert([
                        'uid' => $store_order_info['uid'],
                        'number' => $array_fzone_paytype['price'],
                        'mark' => "{$make}商品申请退款退回VR",
                        'desc' => "VR",
                        'order_type' => 0,
                        'order_id' => $store_order_info['order_id'],
                        'surplus' => $vrpri,
                        'type' => 1,
                        'addtime' => time()
                    ]);

                    // {"checked":true,"note":"VR+积分","other":1.5,"price":8.5,"total":0.0,"type":"b2","vr":"48799.82"}
                    $vrpri = Db::name("user")->where("uid", $group_order_map['uid'])->value('score');
                    $vrpri += $array_fzone_paytype['other'];
                    Db::name("user")->where("uid", $group_order_map['uid'])->update(['score' => $vrpri]);

                    $data = [
                        "uid" => $store_order_info['uid'],
                        "reward_socre" => $array_fzone_paytype['other'],
                        "addtime" => time(),
                        "status" => 1,
                        "order_id" => $store_order_info['order_id'],
                        "mark" => "{$make}商品申请退款退回积分",
                        "surplus" => $vrpri,
                        "pm" => 1,
                        "source_type" => 3
                    ];
                    Db::name("user_sign_score")->insert($data);//添加积分记录
                } else if ($array_fzone_paytype['type'] == 'b2') {
                    // {"checked":true,"note":"现金+积分","other":1.5,"price":8.5,"total":0.0,"type":"b2","vr":"48799.82"}

                    $vrpri = Db::name("user")->where("uid", $group_order_map['uid'])->value('score');
                    $vrpri += $array_fzone_paytype['other'];
                    Db::name("user")->where("uid", $group_order_map['uid'])->update(['score' => $vrpri]);

                    $data = [
                        "uid" => $store_order_info['uid'],
                        "reward_socre" => $array_fzone_paytype['other'],
                        "addtime" => time(),
                        "status" => 1,
                        "order_id" => $store_order_info['order_id'],
                        "mark" => "{$make}商品申请退款退回积分",
                        "surplus" => $vrpri,
                        "pm" => 1,
                        "source_type" => 3
                    ];
                    Db::name("user_sign_score")->insert($data);//添加积分记录
                } else if ($array_fzone_paytype['type'] == 'b3') {
                    // VR+积分 {"checked":true,"note":"VR+积分","other":210.0,"price":970.0,"total":0.0,"type":"b1","vr":"47557.5"}
                    $vrpri = Db::name("user")->where("uid", $group_order_map['uid'])->value('vr');
                    $vrpri += $array_fzone_paytype['price'];
                    Db::name("user")->where("uid", $group_order_map['uid'])->update(['vr' => $vrpri]);
                    Db::name("user_sign_vr")->insert([
                        'uid' => $store_order_info['uid'],
                        'number' => $array_fzone_paytype['price'],
                        'mark' => "{$make}商品申请退款退回VR",
                        'desc' => "VR",
                        'order_type' => 0,
                        'order_id' => $store_order_info['order_id'],
                        'surplus' => $vrpri,
                        'type' => 1,
                        'addtime' => time()
                    ]);

                    // {"checked":true,"note":"VR+积分","other":1.5,"price":8.5,"total":0.0,"type":"b2","vr":"48799.82"}
                    $vrpri = Db::name("user")->where("uid", $group_order_map['uid'])->value('jingdou');
                    $vrpri += $array_fzone_paytype['other'];
                    Db::name("user")->where("uid", $group_order_map['uid'])->update(['jingdou' => $vrpri]);

                    Db::name('user_sign_jingdou')->insert([
                        'uid' => $store_order_info['uid'],
                        'number' => $array_fzone_paytype['other'],
                        'status' => 1,
                        'mark' => "{$make}商品申请退款退回京豆",
                        'addtime' => time(),
                        'surplus' => $vrpri,
                        'settlement_time' => date('Y-m-d H:i:s'),
                        'type' => 1,
                        'order_type' => 0,
                        'order_id' => $store_order_info['order_id']
                    ]);
                } else if ($array_fzone_paytype['type'] == 'b4') {
                    // {"checked":true,"note":"现金+积分","other":1.5,"price":8.5,"total":0.0,"type":"b2","vr":"48799.82"}

                    $jingdoupri = Db::name("user")->where("uid", $group_order_map['uid'])->value('jingdou');
                    $jingdoupri += $array_fzone_paytype['other'];
                    Db::name("user")->where("uid", $group_order_map['uid'])->update(['jingdou' => $jingdoupri]);

                    Db::name('user_sign_jingdou')->insert([
                        'uid' => $store_order_info['uid'],
                        'number' => $array_fzone_paytype['other'],
                        'status' => 1,
                        'mark' => "{$make}商品申请退款退回京豆",
                        'addtime' => time(),
                        'surplus' => $jingdoupri,
                        'settlement_time' => date('Y-m-d H:i:s'),
                        'type' => 1,
                        'order_type' => 0,
                        'order_id' => $store_order_info['order_id']
                    ]);
                } else if ($array_fzone_paytype['type'] == 'b5') {
                    // {"checked":true,"note":"VR","other":0.0,"price":1.0,"total":0.0,"type":"b5","vr":"10"}
                    $vrpri = Db::name("user")->where("uid", $group_order_map['uid'])->value('vr');
                    $vrpri += $array_fzone_paytype['price'];
                    Db::name("user")->where("uid", $group_order_map['uid'])->update(['vr' => $vrpri]);
                    Db::name("user_sign_vr")->insert([
                        'uid' => $store_order_info['uid'],
                        'number' => $array_fzone_paytype['price'],
                        'mark' => "{$make}商品申请退款退回VR",
                        'desc' => "VR",
                        'order_type' => 0,
                        'order_id' => $store_order_info['order_id'],
                        'surplus' => $vrpri,
                        'type' => 1,
                        'addtime' => time()
                    ]);
                } else if ($array_fzone_paytype['type'] == 'a3') {
                    // {"checked":true,"note":"现金+VR","other":1.5,"price":8.5,"total":0.0,"type":"a3","vr":"48799.82"}
                    $vrpri = Db::name("user")->where("uid", $group_order_map['uid'])->value('vr');
                    $vrpri += $array_fzone_paytype['other'];
                    Db::name("user")->where("uid", $group_order_map['uid'])->update(['vr' => $vrpri]);

                    //VR入账
                    $insertdata = [
                        'uid'=> $store_order_info['uid'],
                        'number' =>  $array_fzone_paytype['other'],
                        'surplus' => $vrpri,
                        'mark' => "{$make}商品申请退款退回VR",
                        'order_id'=> $store_order_info['order_id'],
                        'type' => 2,
                        'addtime' => time(),
                        'settlement_time'=> date('Y-m-d H:i:s', time())
                    ];
                    Db::name('user_sign_vr')->insert($insertdata);

                } else if ($array_fzone_paytype['type'] == 'c1') {
                    // {"checked":true,"note":"复购金","other":1.5,"price":8.5,"total":0.0,"type":"c1","vr":"48799.82"}
                    $vrpri = Db::name("user")->where("uid", $group_order_map['uid'])->value('fugou');
                    $vrpri += $array_fzone_paytype['price'];
                    Db::name("user")->where("uid", $group_order_map['uid'])->update(['fugou' => $vrpri]);
                    //支出账号存到log日志
                    $log_data = [
                        'uid' => $store_order_info['uid'],
                        'number' => $array_fzone_paytype['price'],
                        'mark' => "复购区商品申请退款退回复购金:" . $array_fzone_paytype['price'],
                        'desc' => "复购金",
                        'order_id' => $store_order_info['order_id'],
                        'surplus' => $vrpri,
                        'order_type' => 0,
                        'type' => 1,
                        'addtime' => time()
                    ];
                    Db::name("user_sign_fugou")->insert($log_data);
                }
            }

            // 取消 订单所发放的福利
            $this->repository->cancelOrderBonus($id);
        }else{
            $fail_message = $this->request->param('fail_message','');
            if($status == -1 && empty($fail_message)){
                return app('json')->fail('未通过必须填写');
            }

            if($fail_message==''){
                return app('json')->fail('未通过必须填写');
            }

            $data['status'] = $status;
            $data['fail_message'] = $fail_message;
            $this->repository->refuse($id,$data);

            $this->repository->set_consult(2,$id);//协商记录
        }
        return app('json')->success('审核成功');
    }
    public function switchStatusjhm($id)
    {
        $this->repository->agreejhm($id);
        return app('json')->success('审核成功');
    }
    public function switchStatusnf($id)
    {
        $res = $this->repository->agreenf($id);
        return app('json')->success($res);
    }
    public function switchStatusqds($id)
    {
        $res = $this->repository->agreeqds($id);
        return app('json')->success($res);
    }

    /**
     * TODO 收货后确定退款
     * @param $id
     * @return mixed
     * @author Qinii
     * @day 2020-06-12
     */
    public function refundPrice($id)
    {
        if(!$this->repository->getRefundPriceExists($this->request->merId(),$id))
            return app('json')->fail('信息或状态错误');


        if($this->request->param('status') == 2){
            $part_refund_message = $this->request->param('part_refund_message','');
            $refund_price =(float) $this->request->param('part_refund_price',0);
            if($refund_price<0.01){
                return app('json')->fail('退款金额不能小于0.01');
            }
            $refund_order=$this->repository->get($id);

            $pay_price=Db::name('store_order')->where('order_id',$refund_order['order_id'])->value('pay_price');
            if($refund_price > $pay_price){
                return app('json')->fail('退款金额不能大于用户支付金额');
            }
            if($part_refund_message==''){
                return app('json')->fail('请填写商家备注');
            }
            $this->repository->update($id,['refund_price'=>$refund_price,'part_refund_price'=>$refund_price,'part_refund_message' => $part_refund_message,'part_refund_time'=>date('Y-m-d H:i:s')]);

        }else if($this->request->param('status') == -1){
            $fail_message = $this->request->param('fail_message','');
            if(empty($fail_message))
                return app('json')->fail('请输入拒绝原因');
            $data['status'] = -1;
            $data['fail_message'] = $fail_message;
            $this->repository->refuse($id,$data);
            $this->repository->set_consult(7,$id);//协商记录
            return app('json')->success('拒绝成功');
        }
        $this->repository->set_consult(5,$id);//协商记录
        $this->repository->adminRefund($id,$this->request->adminId());
        return app('json')->success('退款成功');
    }

    /**
     * TODO
     * @param $id
     * @return mixed
     * @author Qinii
     * @day 2020-06-12
     */
    public function switchStatusForm($id)
    {
        if(!$this->repository->getStatusExists($this->request->merId(),$id))
            return app('json')->fail('信息或状态错误');
//        $douduo = $this -> repository -> douduofund($id,false);
//        if($douduo['code'] < 0){
//            return app('json')->fail($douduo['message']);
//        }
//        if($douduo['code'] == 2){
//            return app('json')->success($douduo['message']);
//        }
        return app('json')->success(formToData($this->repository->statusForm($id)));
    }

    /**
     * TODO
     * @param $id
     * @return mixed
     * @author Qinii
     * @day 2020-06-18
     */
    public function delete($id)
    {
        if(!$this->repository->getUserDelExists($this->request->merId(),$id))
            return app('json')->fail('信息或状态错误');
        $this->repository->update($id,['is_system_del' => 1]);
        return app('json')->success('删除成功');
    }

    /**
     * TODO
     * @param $id
     * @return mixed
     * @author Qinii
     * @day 2020-06-18
     */
    public function markForm($id)
    {
        if(!$this->repository->getExistsById($this->request->merId(),$id))
            return app('json')->fail('数据不存在');
        return app('json')->success(formToData($this->repository->markForm($id)));
    }

    /**
     * TODO
     * @param $id
     * @return mixed
     * @author Qinii
     * @day 2020-06-18
     */
    public function mark($id)
    {
        if(!$this->repository->getExistsById($this->request->merId(),$id))
            return app('json')->fail('数据不存在');
        $this->repository->update($id,['mer_mark' => $this->request->param('mer_mark','')]);

        return app('json')->success('备注成功');
    }

    public function log($id)
    {
        list($page,$limit) = $this->getPage();
        $make = app()->make(StoreRefundStatusRepository::class);
        return app('json')->success($make->search($id,$page,$limit));
    }

    public function reList($id)
    {
        [$page,$limit] = $this->getPage();
        $make = app()->make(MerchantReconciliationRepository::class);
        if(!$make->getWhereCount(['mer_id' => $this->request->merId(),'reconciliation_id' => $id]))
            return app('json')->fail('数据不存在');
        $where = ['reconciliation_id' => $id,'type' => 1];
        return app('json')->success($this->repository->reconList($where,$page,$limit));
    }

    /**
     * TODO 快递查询
     * @param $id
     * @return mixed
     * @author Qinii
     * @day 2020-06-25
     */
    public function express($id)
    {
//        if(!$this->repository->getWhereCount(['refund_order_id' => $id,'status' =>2]))
//            return app('json')->fail('订单信息或状态错误');
        return app('json')->success($this->repository->express($id));
    }
}
